Summary: HTTP server daemon with SSL
Name: apache
Version: 2.0.52
Release: 0.1tr
Group: Network/Services
Source0: http://httpd.apache.org/dist/httpd/httpd-%{version}.tar.bz2
Patch0: apache_2.0.45-trustix.patch
# security:
Patch1: apache-2.0.52-CAN-2004-0942.patch

Source3: httpd.init
Source4: httpd.log
Source5: gendummycerts
Source6: httpd2.conf
Source7: SmallSSL.gif
Source8: trustix-html.tar.gz
Source10: server.crt
Source11: server.csr
Source12: server.key
# No longer used.  Still kept for reference.
#Source15: httpd-srm.conf
#Source16: httpd-access.conf
License: BSD-like
Obsoletes: libapr
Provides: apache-ssl securewebserver webserver apache
BuildRoot: /var/tmp/%{name}-root
Requires: initscripts >= 3.25
Requires: openssl >= 0.9.6e
Requires: mailcap 
Prereq: /sbin/restart_maybe chkconfig
BuildRequires: openssl-devel >= 0.9.6e 
URL: http://www.apache.org/

%description
Apache is a full featured web server that is freely available, and also
happens to be the most widely used.

Built with loadable modules (all standard modules enabled).
This verion is intended as a replacement for a standard apache, the
configuration files provided with apache and apache-ssl are unchanged.


%package devel
Group: Libraries/Development
Summary: Development tools for the Apache Web server.
Obsoletes: libapr-devel

%description devel
The apache-devel package contains the development libraries and header files
for the Apache Web server and the APXS binary you'll need to build Dynamic
Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be
able to compile or develop additional modules for Apache, you'll
need to install this package.

%package manual
Group: Documentation
Summary: The manual for the Apache HTTPd.

%description manual
The manual for the Apache HTTP server.

%prep
%setup -q -n httpd-%{version}
%patch0 -p1
%patch1 -p0

%build
CFLAGS=$RPM_OPT_FLAGS && ./configure %{_target_platform}\
	--enable-layout=Trustix \
	--enable-module=all \
	--enable-mods-shared=max \
	--enable-auth-dbm=shared \
	--enable-file-cache=shared \
	--enable-cache=shared \
	--enable-disk-cache=shared \
	--enable-mem-cache=shared \
	--enable-ext-filter=shared \
	--enable-deflate=shared \
	--enable-headers=shared \
    --enable-dav=shared \
    --enable-dav-fs=shared \
    --enable-auth-digest=shared \
	--enable-usertrack=shared \
	--enable-unique-id=shared \
	--enable-proxy=shared \
	--enable-proxy-ftp=shared \
	--enable-proxy-http=shared \
	--enable-bucketeer=shared \
	--enable-http \
	--enable-cgi=shared \
	--enable-rewrite=shared \
	--enable-so \
	--enable-ssl=shared \
	--with-perl=/usr/bin/perl \
	--enable-suexec \
	--with-suexec-docroot=/home/httpd/html \
	--with-suexec-caller=httpd \
	--with-suexec-bin=/usr/sbin/suexec \
	--with-mpm=prefork

make
#make certificate TYPE=dummy

%install
rm -fr $RPM_BUILD_ROOT
make install DESTDIR="$RPM_BUILD_ROOT"

# Remove silly html pages, copy in our own index.html
rm $RPM_BUILD_ROOT/home/httpd/html/index.html*
cd $RPM_BUILD_ROOT/home/httpd/html/
tar zxvf %SOURCE8
cd -

# Install rc-script
mkdir -p $RPM_BUILD_ROOT%{_initdir}
install $RPM_SOURCE_DIR/httpd.init $RPM_BUILD_ROOT%{_initdir}/httpd

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/certs
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d

# Logrotate
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/httpd.log $RPM_BUILD_ROOT/etc/logrotate.d/httpd

# Move certain binaries to their correct place
mkdir -p $RPM_BUILD_ROOT/usr/{bin,sbin}
install $RPM_SOURCE_DIR/gendummycerts $RPM_BUILD_ROOT/usr/bin/gendummycerts
#mv $RPM_BUILD_ROOT/home/httpd/sbin/httpd $RPM_BUILD_ROOT/usr/sbin/httpd
mkdir -p $RPM_BUILD_ROOT/var/log/httpd
mkdir -p $RPM_BUILD_ROOT/var/spool/proxy
mkdir $RPM_BUILD_ROOT/home/httpd/cache

install -m644 $RPM_SOURCE_DIR/httpd2.conf \
        $RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

find $RPM_BUILD_ROOT -type f | \
        xargs grep -l "/usr/local/bin/perl5" | \
        xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
        xargs grep -l "/usr/local/bin/perl" | \
        xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

#install $RPM_SOURCE_DIR/server.crt \
#        $RPM_BUILD_ROOT/etc/httpd/conf/certs/server.crt
#install $RPM_SOURCE_DIR/server.csr \
#        $RPM_BUILD_ROOT/etc/httpd/conf/certs/server.csr
#install $RPM_SOURCE_DIR/server.key \
#        $RPM_BUILD_ROOT/etc/httpd/conf/certs/server.key

# Da vacuum cleaner
rm -f $RPM_BUILD_ROOT/home/httpd/html/*.gif || :
rm -f $RPM_BUILD_ROOT/home/httpd/html/*.png || :
rm -f $RPM_BUILD_ROOT/home/httpd/cgi-bin/* || :
rm -f docs/conf/magic || :
rm -f docs/conf/mime-types || :
for i in highperformance-std.conf highperformance.conf httpd-std.conf \
         ssl-std.conf ssl.conf; do
         mv $RPM_BUILD_ROOT/etc/httpd/conf/$i docs/conf/
done 

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%pre
if [ -z "`getent group httpd`" ]; then
        /usr/sbin/groupadd -g 109 httpd
fi
if [ -z "`getent passwd httpd`" ]; then
        /usr/sbin/useradd -d /no/dir -M -s /bin/false \
        -g httpd -u 109 httpd
fi 

%post
# Adding nessesary symlinks.
chkconfig --add httpd

# Restart service after upgrade.
/sbin/restart_maybe httpd


%preun
if [ $1 = 0 ]; then
   if [ -f /mnt/lockdev/httpd ]; then
       %{_initdir}/httpd stop
   fi
   /sbin/chkconfig --del httpd
fi


%files
%defattr(-,root,root)
%doc ABOUT_APACHE CHANGES INSTALL LICENSE README README.platforms VERSIONING
%config(noreplace) /etc/httpd/conf/*.conf
%config(noreplace) /etc/httpd/conf/magic
%config(noreplace) /etc/logrotate.d/httpd
%config(noreplace) /home/httpd/html/*.css
%config(noreplace) /home/httpd/html/*.html
%dir /etc/httpd/conf
%dir /etc/httpd/conf.d
%dir /home/httpd
%dir /home/httpd/html
%doc docs/conf docs/cgi-examples
%{_initdir}/httpd
%{_mandir}/*/*
/etc/httpd/conf/certs
/etc/httpd/logs
/etc/httpd/modules
/home/httpd/build
/home/httpd/cache
/home/httpd/cgi-bin
/home/httpd/error
/home/httpd/html/images
/home/httpd/icons
/usr/bin/*
/usr/lib/*.so.*
/usr/lib/apache
/usr/sbin/*
/var/log/httpd
/var/spool/proxy

%files devel
%defattr(-,root,root)
/usr/lib/*.a
/usr/lib/*.la
/usr/lib/*.so
/usr/include/apache

%files manual
%defattr(-,root,root)
/home/httpd/html/manual


%changelog
* Thu Nov 18 2004 Erlend Midttun <erlendbm at trustix dot org> 2.0.52-0.1tr
- New upstream.

* Thu Sep 23 2004 Oystein Viggen <oysteivi at trustix dot com> 2.0.51-0.2tr
- Patch CAN-2004-0811

* Thu Sep 16 2004 Erlend Midttun <erlendbm at trustix dot org> 2.0.51-0.1tr
- New upstream fixes CAN-2004-0786 CAN-2004-0747 CAN-2004-0751 
  CAN-2004-0748 and CAN-2004-0809

* Thu Jul 22 2004 Oystein Viggen <oysteivi at trustix dot com> 2.0.50-1tr
- New upstream

* Tue Jun 29 2004 Oystein Viggen <oysteivi at trustix dot com> 2.0.49-4tr
- Add patch for CAN-2004-0493 DoS issue

* Wed Jun  2 2004 Chr. Toldnes <christht at trustix dot org> 2.0.49-3tr
- Now use the correct init script

* Wed Jun  2 2004 Chr. Toldnes <christht at trustix dot org> 2.0.49-2tr
- Added patch to fix CAN-2004-0488

* Fri Mar 26 2004 Oystein Viggen <oysteivi at trustix dot com> 2.0.49-1tr
- New upstream version: 2.0.49

* Thu Oct 30 2003 Chr. Toldnes <christht at trustix dot org> 2.0.48-1tr
- New upstream version: 2.0.48

* Fri Sep 26 2003 Tor Hveem <torh at trustix dot org> 2.0.47-4th
- Fixed up suexec

* Fri Sep 12 2003 Tor Hveem <torh at trustix dot org> 2.0.47-3th
* Included dav modules, and auth-digest module 

* Thu Jul 10 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.47-2tr
- Take II, now woth changes from 46-6tr.

* Thu Jul 10 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.47-1tr
- New upstream, closes serveral security related problems.

%changelog
* Fri Jul  8 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.46-6tr
- Removed directory browsing by default.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.46-5tr
- Big rebuild

* Tue Jun 10 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.46-4em
- Added WAP headers.
- Added missingok and notifempty to logrotate-config.

* Thu Jun  5 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.46-3em
- Try to resolve file conflicts.

* Fri May 30 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.46-2em
- Merge the packages.

* Thu May 29 2003 Gerald Dachs <gda at trustix dot org> 2.0.46-1gd
- Upgrade to 2.0.46

* Mon Apr 28 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.45-3em
- Fixed creation of home directory.

* Mon Apr 28 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.45-2em
- Cleaned up config.  No longer load proxy modules.
- Added httpd user/group

* Fri Apr  4 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.45-1em
- Upgrade to 2.0.45

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.44-4em
- Rebuilt against glibc 2.3.2.

* Fri Feb 28 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.44-3em
- Major cleanup of spec file.
- Major cleanup of /etc/httpd.
- Major cleanup of /home/httpd.
- Created manual package.

* Wed Feb 19 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.44-2em
- Added Include directory.
- Added commented out PHP4 module line.

* Wed Jan 22 2003 Tor Hveem <torh at trustix dot org> 2.0.44-1th
- new version

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 2.0.43-4gd
- rebuild against openssl 0.9.7
- Make initscript use lockdev instead of .lockdev

* Tue Jan  7 2003 Erlend Midttun <erlendbm at trustix dot com> 2.0.43-3em
- Make initscript use .lockdev instead of lockdev
- Use initdir macro
- Removed axps from -devel so that it is part of main package.

* Thu Nov 21 2002 Christian H. Toldnes <christht at trustix dot com> 2.0.43-2ct
- httpd initscript now uses $INITLOCK

* Tue Oct  8 2002 Gerald Dachs <gda at trustix dot org> 2.0.43-1gd
- new upstream version

* Fri Sep 13 2002 Nico Erfurth <masta at trustix dot org> 2.0.40-2ne
- Splitted libapr into a seperate package
- fixed httpd.init to use the new init-directory

* Tue Aug 27 2002 Nico Erfurth <masta at trustix dot org> 2.0.40-1ne
- Updated to Apache 2.0.40
- FIXME: ssl-config, no certs are generated

* Wed Jul 17 2002 Roland Kruse <rolandk at trustix dot com> 1.3.26-4rk 
- rcscripts /etc/rc.d/init.d -> /etc/init.d

* Tue Jul 16 2002 Roland Kruse <rolandk at trustix dot com> 1.3.26-3rk
- Rebuild for Cloud (temporary, will be replaced with 2.x)

* Mon Jun 24 2002 Christian H. Toldnes <christht at trustix dot com> 1.3.26-2tr
- Update to mod_ssl-2.8.10 fixes buffer overflow

* Wed Jun 19 2002 Christian H. Toldnes <christht at trustix dot com> 1.3.26-1tr
- Update to apache-1.3.26 mod_ssl-2.8.9
- Added index.php to DirectoryIndex in httpd.conf
- Added missing file apachectl

* Wed May 15 2002 Erlend Midttun <erlendbm at trustix dot com>
- Seems openssl-devel is not needed as PreReq.  Moving to BuildRequires.

* Tue May 14 2002 Erlend Midttun <erlendbm at trustix dot com>
- Added Include /etc/httpd/conf.d in config file
- Added /etc/httpd/conf.d to allow applications to configure apache
  without fscking the normal config file.
- No longer remove apachectl as it provides more features than our
  SYSV scripts.  "apachectl configtest" for one.  Hopefully it will not
  break anything.
- Added poweredbytrustix.png.
- Resynced config file with default.

* Mon Apr 15 2002 Christian H. Toldnes <christht at trustix dot com>
- New upstream version: apache 1.3.24, modssl 2.8.8

* Fri Mar  1 2002 Christian H. Toldnes <christht at trustix dot com>
- Correct chkconfig handling in init script.

* Thu Feb 28 2002 Christian H. Toldnes <christht at trustix dot com>
- New upstream version: apache 1.3.23, modssl 2.8.7
- Added new set of files for default page.

* Mon Jan  7 2002 Christian H. Toldnes <christht at trustix dot com>
- Added %config(noreplace) for default html-pages.

* Thu Jan  3 2002 Christian H. Toldnes <christht at trustix dot com>
- Package cleanup.

* Wed Dec 19 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed logrotate.  Take II.

* Thu Nov 29 2001 Erlend Midttun <erlendbm at trustix dot com>
- Removed poweredby.gif.
- Fixed logrotate.

* Thu Oct  4 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed missing dependency of mailcap.

* Thu Jul 26 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed version string to make webmin happy.

* Mon Jul 23 2001 Erlend Midttun <erlendbm at trustix dot com>
- Seems like we overwrote the config files. 

* Mon Jul  9 2001 Erlend Midttun <erlendbm at trustix dot com>
- Due to a large number of AOL users thinking we stole their favorite
  website, we've changed the "it worked" page.

* Mon Jun 18 2001 Erlend Midttun <erlendbm at trustix dot com>
- Second attempt at getting /var/log/httpd going.
- Added support for auth_dbm.

* Tue Jun 12 2001 Erlend Midttun <erlendbm at trustix dot com>
- New upstream version.

* Mon Mar 19 2001 Alexander Reelsen <ar at trustix dot com>
- Updated to version 1.3.19
- Replaced apache-ssl with mod_ssl (now one package for SSL/non-SSL apache)
- Added apache-contrib module sources
- General spec file cleanup

* Sat Nov 25 2000 Oystein Viggen <oysteivi at trustix dot com>
- The new version needs --disable-shared=apache_ssl to actually work

* Wed Nov 22 2000 Olaf Trygve Berglihn <olafb at trustix dot com>
- Updated to version 1.3.14+ssl_1.42.

* Wed Oct 4 2000 Per Ivar Paulsen <perp at trustix dot com>
- Fixed mod-rewrite.c bug

* Tue Aug 15 2000 Oystein Viggen <oysteivi at trustix dot com>
- Security hole through typo in attr for /usr/sbin/httpsd fixed.

* Wed May 24 2000 Per Ivar Paulsen <perp at trustix dot com>
- Bugfix, downgrade to apache-ssl 1.39

* Wed May 3 2000 Per Ivar Paulsen <perp at trustix dot com>
- Update apache-ssl to 1.40

* Tue Mar 14 2000 Per Ivar Paulsen <perp at trustix dot com>
- Updated to apache 1.3.12 and apache-ssl 1.39

* Tue Feb 21 2000 Per Ivar Paulsen <perp at trustix dot com>
- Initial release for the Trustix Secure Linux distribution.
- Added noreplace.
- Moved man and info pages to /usr/share adhering to FHS
- TODO: add better default configuration
- Added Apache 1.3.11 and apache_1.3.11+ssl_1.38.

